import { EventEmitter } from "eventemitter3";
import feathers = require("feathers");
import Gateway from "./Gateway";
export default class Client extends EventEmitter {
    config: any;
    gateways: Gateway[];
    readonly restGateway: Gateway;
    readonly restApp: feathers.Service<any>;
    readonly messageService: feathers.Service<any>;
    readonly configuration: any;
    private connected;
    private ready;
    constructor(config: any);
    rest(method: string, ...args: any[]): Promise<any>;
    service(name: string, callback: (service: any) => Promise<any>, first?: boolean): Promise<any>;
    get(name: string, id: string, first?: boolean): Promise<any>;
    find(name: string, query: any, first?: boolean): Promise<any>;
    addGauge(name: string, help: string, labelNames?: string[]): void;
    connect(): Promise<void>;
}
