import { Message } from "eris";
import CommandClient from "../CommandClient";
import CommandContext from "./CommandContext";
import CommandInterface from "./CommandInterface";
export interface MessageInterface {
    message: Message;
    joined: boolean;
}
export default abstract class AbstractCommand implements CommandInterface {
    protected client: CommandClient;
    protected context: CommandContext;
    constructor(client: CommandClient, context: CommandContext);
    abstract process(message?: any): Promise<void>;
    protected reply(content: any): Promise<MessageInterface>;
    protected getMessage(message: any): Promise<Message>;
    protected deleteMessage(message: any): Promise<void>;
    protected editMessage(message: any, content: any): Promise<Message>;
    protected sendMessage(channel: string | any, content: any): Promise<MessageInterface>;
    protected reactOk(): Promise<void>;
    protected reactNotOk(): Promise<void>;
    protected embedMessage(callback: (x: any) => any): Promise<MessageInterface>;
}
