"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Parameter_1 = require("../Command/Parameter");
exports.default = (...args) => {
    return (target, propertyKey) => {
        let parameter = new Parameter_1.default();
        if (typeof args[0] === "string") {
            parameter = new Parameter_1.default(args[0]);
            args = args.splice(0, 1);
        }
        for (const key in args[0]) {
            if (args[0].hasOwnProperty(key)) {
                parameter[key] = args[0][key];
            }
        }
        if (parameter.multiple) {
            parameter.defaultValue = [];
        }
        Reflect.defineMetadata("parameter", parameter, target, propertyKey);
        const metadata = Reflect.getOwnMetadata("command", target) || {};
        metadata.parameters = (metadata.parameters || []).concat([parameter]);
        Reflect.defineMetadata("command", metadata, target);
    };
};
//# sourceMappingURL=Parameter.js.map