import * as feathers from "feathers/client";
import { Gauge } from "prom-client";
import Client from "./Client";
export default class Gateway {
    private client;
    private url;
    app: feathers.Application;
    connected: boolean;
    configuration: any;
    gauges: {
        [name: string]: Gauge;
    };
    readonly rest: boolean;
    private registry;
    private socket;
    private storage;
    private authenticating;
    private authenticated;
    private authToken;
    private reconnectInterval;
    constructor(client: Client, url: string);
    authenticate(): Promise<{}>;
    addGauge(nick: string, help: string, labelNames?: string[]): void;
    emit(event: string, ...args: any[]): void;
    on(event: any, callback: (x: any) => any): void;
    private configure(callback?);
}
